{% load custom_tags %}

<div class="col-md-6 col-sm-12">
    <div class="x_panel tile fixed_height_320 overflow_hidden">
        <div class="x_title">
            <h2>{{ titulo }}</h2>
            <ul class="nav navbar-right panel_toolbox">
                <li>
                    <a class="collapse-link"
                        ><i class="fa fa-chevron-up"></i
                    ></a>
                </li>
                {% if jsonify_queryset_opts_estado %}
                <li class="dropdown">
                    <a
                        href="#"
                        class="dropdown-toggle"
                        data-toggle="dropdown"
                        role="button"
                        aria-expanded="false"
                        ><i class="fa fa-wrench"></i
                    ></a>
                    <ul
                        class="dropdown-menu estados"
                        data-canvas="{{ titulo | slugify }}"
                        role="menu"
                    >
                        <li>
                            <a href="#" class="filtra_estado"><b>Brasil</b></a>
                        </li>
                        <li><a href="#" class="filtra_estado">Acre</a></li>
                        <li><a href="#" class="filtra_estado">Alagoas</a></li>
                        <li><a href="#" class="filtra_estado">Amapá</a></li>
                        <li><a href="#" class="filtra_estado">Amazonas</a></li>
                        <li><a href="#" class="filtra_estado">Bahia</a></li>
                        <li><a href="#" class="filtra_estado">Ceará</a></li>
                        <li>
                            <a href="#" class="filtra_estado"
                                >Distrito Federal</a
                            >
                        </li>
                        <li>
                            <a href="#" class="filtra_estado">Espírito Santo</a>
                        </li>
                        <li><a href="#" class="filtra_estado">Goiás</a></li>
                        <li><a href="#" class="filtra_estado">Maranhão</a></li>
                        <li>
                            <a href="#" class="filtra_estado">Mato Grosso</a>
                        </li>
                        <li>
                            <a href="#" class="filtra_estado"
                                >Mato Grosso do Sul</a
                            >
                        </li>
                        <li>
                            <a href="#" class="filtra_estado">Minas Gerais</a>
                        </li>
                        <li><a href="#" class="filtra_estado">Pará</a></li>
                        <li><a href="#" class="filtra_estado">Paraíba</a></li>
                        <li><a href="#" class="filtra_estado">Paraná</a></li>
                        <li>
                            <a href="#" class="filtra_estado">Pernambuco</a>
                        </li>
                        <li><a href="#" class="filtra_estado">Piauí</a></li>
                        <li>
                            <a href="#" class="filtra_estado">Rio de Janeiro</a>
                        </li>
                        <li>
                            <a href="#" class="filtra_estado"
                                >Rio Grande do Norte</a
                            >
                        </li>
                        <li>
                            <a href="#" class="filtra_estado"
                                >Rio Grande do Sul</a
                            >
                        </li>
                        <li><a href="#" class="filtra_estado">Rondônia</a></li>
                        <li><a href="#" class="filtra_estado">Roraima</a></li>
                        <li>
                            <a href="#" class="filtra_estado">Santa Catarina</a>
                        </li>
                        <li><a href="#" class="filtra_estado">São Paulo</a></li>
                        <li><a href="#" class="filtra_estado">Sergipe</a></li>
                        <li><a href="#" class="filtra_estado">Tocantins</a></li>
                    </ul>
                </li>
                {% endif %}
                <li>
                    <a class="close-link"><i class="fa fa-close"></i></a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <canvas
                class="canvasDoughnut"
                id="canvas-{{ titulo|slugify }}"
                data-label_field="{{ label_field }}"
                data-value_field="{{ value_field }}"
                data-estado_field="{{ estado_field }}"
                data-value_estado_field="{{ value_estado_field }}"
                style="width: 100%; height: 230px"
            >
            </canvas>
        </div>
    </div>
</div>
<script type="text/javascript">
    $(document).ready(function () {
        if (typeof (Chart) === 'undefined') {
            return;
        }

        if ($('#canvas-{{ titulo | slugify }}').length) {
            data['{{ titulo | slugify }}'] = {{ dados | jsonify_queryset:jsonify_queryset_opts | safe}};
            {% if jsonify_queryset_opts_estado and dados_por_estado %}
                dataEstados['{{ titulo | slugify }}'] = {{ dados_por_estado | jsonify_queryset:jsonify_queryset_opts_estado | safe}};
            {% endif %}

            var labels = data['{{ titulo | slugify }}'].map((elm) => elm['{{ label_field }}']);
            var values = data['{{ titulo | slugify }}'].map((elm) => elm['{{ value_field }}']);

            /*
            if (values.length > 6) {
                var limit = 6;
                while (values[limit] === values[limit-1] && limit > 2) {
                    limit--;
                }
                var old_values = [...values];
                var old_labels = [...labels];
                values = []
                labels = []
                for (var i=0; i<limit; i++) {
                    values[i] = old_values[i];
                    labels[i] = old_labels[i];
                }
                values[limit] = 0;
                for (var j=limit; j<old_values.length; j++) {
                    values[limit] += old_values[j];
                }
                labels[limit] = "Outros";
            }
            */


            var cahrt_settings = {
                plugins: [ChartDataLabels],
                type: '{{ tipo_grafico }}',
                tooltipFillColor: "rgba(51, 51, 51, 0.55)",
                data: {
                    labels: labels,
                    datasets: [{
                        data: values,
                        backgroundColor: [
                            "#BDC3C7",
                            "#9B59B6",
                            "#E74C3C",
                            "#26B99A",
                            "#3498db",
                            "#f6cd55",
                            "#db700b"
                        ],
                        hoverBackgroundColor: [
                            "#CFD4D8",
                            "#B370CF",
                            "#E95E4F",
                            "#36CAAB",
                            "#49a9ea",
                            "#f6d269",
                            "#e08028"
                        ],
                        datalabels: {
                            anchor: 'center',
                            color: '#000',
                            labels: {
                                value: {
                                    weight: 'bold'
                                }
                            },
                            formatter: function(value, context) {
                                return value + '\n(' + Math.round(value*100/context.chart.config.options.total) + '%)';
                            },
                            textAlign: 'center'
                        }
                    }]
                },
                options: {
                    title: {
                        display: false,
                        text: 'estado',
                        padding: 0
                    },
                    legend: {
                        display: false,
                        position: 'right'
                    },
                    tooltips: {
                        "enabled": false
                    },
                    layout: {
                        padding: {
                          left: 0,
                            right: 0,
                            top: 15,
                            bottom: 0
                        }
                    },
                    responsive: false,
                    scales: {
                        yAxes: [{
                            ticks: {
                                beginAtZero: true
                            }
                        }]
                    },
                    total: calcula_total(values)
                }
            }

            $('#canvas-{{ titulo|slugify }}').each(function () {
                var chart_element = $(this);
                charts['{{ titulo|slugify }}'] = new Chart(chart_element, cahrt_settings);
            });
        }

    });
</script>
